# Polihack

See the API's [documentation](DOCS.md).

## Commands

After you generate your project, these commands are available in `package.json`.

```bash
npm run lint # lint using ESLint
npm run dev # run the API in development mode
npm run prod # run the API in production mode
npm run docs # generate API docs
```

## Playing locally

First, you will need to install and run [MongoDB](https://www.mongodb.com/) in another terminal instance.

```bash
$ mongod
```

Then, run the server in development mode.

```bash
$ npm run dev
Express server listening on http://0.0.0.0:9000, in development mode
```

If you choose to generate the authentication API, you can start to play with it.
> Note that creating and authenticating users needs a master key (which is defined in the `.env` file)

## Directory structure

### Overview

```
src/
├─ api/
│  ├─ auth/
│  │  ├─ controller.js
│  │  └─ index.js
│  ├─ category/
│  │  ├─ controller.js
│  │  ├─ index.js
│  │  └─ model.js
│  ├─ challenge/
│  ├─ company/
│  ├─ password-reset/
│  ├─ user/
│  ├─ user-application/
│  └─ index.js
├─ services/
│  ├─ express/
│  ├─ facebook/
│  ├─ google/
│  ├─ jwt/
│  ├─ mongoose/
│  ├─ passport/
│  ├─ response/
│  └─ sendgrid/
├─ app.js
├─ config.js
├─ constants.js
└─ index.js
```

### `src/api/`

Here is where the API endpoints are defined. Each API has its own folder.

#### `src/api/some-endpoint/model.js`

It defines the Mongoose schema and model for the API endpoint. Any changes to the data model should be done here.

#### `src/api/some-endpoint/controller.js`

This is the API controller file. It defines the main router middlewares which use the API model.

#### `src/api/some-endpoint/index.js`

This is the entry file of the API. It defines the routes using, along other middlewares (like session, validation etc.), the middlewares defined in the `some-endpoint.controller.js` file.

### `services/`

Here you can put `helpers`, `libraries` and other types of modules which you want to use in your APIs.
